#!/usr/bin/perl

##############################################################################
# virmeld.cgi (C) J. Fiebig <superlehrer@gmx.de>                             #
# This script is free software. You may redistribute and/or modify  it under #
# the terms and conditions of the GNU General Public License, Version 2      #
#                                                                            #
# There is NO WARRANTY on anything!                                          #
#                                  					     #
# Das Script beruht auf dem Quelltext des Scriptes smbstatus2html.pl für     #
# Arktur 3 von Rene van Bevern                                               #
##############################################################################
# Das Script setzt eine Installation von Bitdefender vorraus.                #
# Dabei sollte bitdefender in /usr/local/bdc/ liegen, damit die Signaturen   #
# in /usr/local/bdc/Plugins/ gefunden werden können.                         #
# Der Aufruf von Bitdefender muss die Standardausgaben nach                  #
# /var/log/bdc.log schreiben.                                                #
# Dies gelingt in Version 7.0 z.B. mit:                                      #
#  bdc /home --all --disinfect > /var/log/bdc.log                            #
# in Version 7.1 mit                                                         #
#  bdc /home --arc --disinfect > /var/log/bdc.log                            #
# in der crontab.                                                            #
# Ein Start vom Script aus ist nicht sinnvoll, da der Scan lange dauern kann #
##############################################################################


# Hier wird konfiguriert über welche Datei der Datenaustausch gemacht wird

$log_file = "/var/log/bdc.log";
$date = `/bin/date \"+%T %e.%m.%Y\"`;

open LOG_OUTPUT, '<'.$log_file;
@log_output = <LOG_OUTPUT>;
close (LOG_OUTPUT);

$update_file = "/tmp/bdc.update";
system "ls -l -t --time-style=+%d.%m.%Y%t-%t%k:%M /usr/local/bdc/Plugins/*.* > /tmp/bdc.update";
# system "ls -l -t --time-style=+%k:%M /usr/local/bdc/Plugins/*.* > /tmp/bdc.update";

open UPDATE_OUTPUT, '<'.$update_file;
@update_output = <UPDATE_OUTPUT>;
close (UPDATE_OUTPUT);


$date_file = "/tmp/bdc.date";
system "ls -l --time-style=+%d.%t%m.%t%Y%tgegen%t%k:%M /var/log/bdc.log > /tmp/bdc.date";
open DATE_OUTPUT, '<'.$date_file;
@date_output = <DATE_OUTPUT>;
close (DATE_OUTPUT);


print "Content-type: text/html\n\n";
print "<HTML>";
print "<head> <link rel=\"stylesheet\" href=\"style.css\">";
print "</head> ";

# print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\"\
#BACKGROUND=\"/online/whttxtr2.jpg\"><FONT SIZE=\"-1\">Datum: $date</FONT><BR><BR>\n";

print "<body background=\"whttxtr2.jpg\">";

print "<center><h2 class=\"title\"><b>Meldungen der Virenpr&uuml;fung</b></h2></center><br>";


foreach $line (@date_output)
{
	@fields = split(/ +/,$line);
	print "<FONT SIZE=\"+2\">Ergebnisse der letzten Virensuche vom $fields[5] ";
	if ($fields[6]!~/var/) { print  $fields[6];}
	print " Uhr:</FONT><BR>"; 
	eo_foreach:
}

$Anzahl=0;
foreach $line (@update_output)
{
	if ($Anzahl==0)
	{@fields = split(/ +/,$line);
	 print "<FONT SIZE=\"-1\">Virensignaturen vom $fields[5] ";
	 if ($fields[6]!~/usr/) {print $fields[6];}
	 print " Uhr </FONT><BR><BR>";
	 $Anzahl=1; 
	} 
	eo_foreach:
}


$Anzahl=0;
$Anzahll=0;

foreach $line (@log_output)
{
	$Anzahll=$Anzahll+1;
	if($line=~/infected:/) {$Anzahl=$Anzahl+1 ; goto eo_foreach;}
	eo_foreach:
}

print "<FONT SIZE=\"+1\"> <STRONG>";
if ($Anzahll==0) {print "Kein Logfile vorhanden!<BR>"}
else
{
if ($Anzahl==0) {print "<FONT SIZE=\"+2\" style=\"color: rgb(51, 205, 0);\">\
                 Ihr System ist virenfrei!<BR></FONT></FONT><BR>\
		 Alle Meldungen:<FONT SIZE=\"+1\"><BR>"} else
{
print "<FONT style=\"color: rgb(0, 0, 255);\">";
if ($Anzahl==1) {print "Es wurde ein Virus gefunden!<BR><BR>";} else 
{print "Es wurden $Anzahl Viren gefunden!<BR><BR>";}
print "</FONT>";
}
}
print "</STRONG></FONT>";

foreach $line (@log_output)
{
	if($line=~/^\s*$/) {goto eo_foreach;}
	if($line=~/Copyright/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/00000000/) {goto eo_foreach;}	
#	if($line=~/Console/) {goto eo_foreach;}	
# ok - Meldungen unterdrücken
	if($line=~/	ok/) {goto eo_foreach;}	
# falls es doch jemand mit --file=... aufgerufen hat
	if($line=~/Results/) {goto eo_foreach;}
	if($line=~/packed with/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/generic unpacked/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/disinfection failed/) {print "$line - L&ouml;schen Sie selbst oder nutzen Sie die Option --delete<BR>"; goto eo_foreach;}
	if($line=~/deleted/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/no scan option/) {print "$line<BR>"; goto eo_foreach;}	
	if($line=~/copied/) {print "$line<BR>"; goto eo_foreach;}
	if($line=~/infected:/) {print "<FONT SIZE=\"+1\" style=\"color: rgb(255, 0, 0);\">$line</FONT><BR>"; goto eo_foreach;}
	if($line=~/Folders/) {print "<br><br>Gepr&uuml;ft wurden:<br>$line &nbsp&nbsp;"; goto eo_foreach;}	
	if($line=~/Infected/) {print "<FONT style=\"color: rgb(0, 0, 255);\">$line</FONT> &nbsp&nbsp;"; goto eo_foreach;}
	if($line=~/Suspect/) {print "<FONT style=\"color: rgb(51, 205, 0);\">$line</FONT> &nbsp&nbsp;"; goto eo_foreach;}
	if($line=~/viruses/) {print "<FONT style=\"color: rgb(0, 0, 255);\">$line</FONT> &nbsp&nbsp;"; goto eo_foreach;}
	print "$line <BR>";
	eo_foreach:
}
 print "<BR>";



print "<br><br><br><FONT SIZE=\"-1\">\
virmeld.cgi - Version 1.1c (C) Mai 2006,<BR>\
f&uuml;r Arktur 4 von <A HREF=\"mailto:JFiebig\@chefmail.de\">J. Fiebig</A> vom\
<A HREF=\"http://www.Erzgebirgskolleg.de\">Erzgebirgskolleg Breitenbrunn</A>.\
</FONT><BR></BODY></HTML>";

system "rm -f /tmp/bdc.date";
system "rm -f /tmp/bdc.update";

exit 1;
